/*
  sid (c) 1999-2003 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /home/cvs/sidblaster/sid/playlist.h,v 1.6 2003/05/22 01:20:56 doj Exp $
*/

#ifndef PLAYLIST__H
#define PLAYLIST__H

#include <string>
#include <vector>

#ifndef __NCURSES_H
#include <curses.h>
#undef clear
#endif

/**
   simple class for handling a playlist. It is soo bad, it's already scheduled for rewrite.
*/
class Playlist
{
 protected:
  /// container type for filenames
  typedef std::vector<std::string> array_t;

  /// filenames managed by this playlist
  array_t a;

  /// currently selected filename
  int current_;
  int cursor;

  WINDOW *playw;
  int width;
  int height;

 public:
  Playlist();
  virtual ~Playlist();

  void init(int& xoffset, int& yoffset, int height_);

  void playinfo_print();

  void up();
  void down();
  void select() { current_=cursor; }

  size_t size() const { return a.size(); }

  const std::string current();
  Playlist& next();
  Playlist& previous();
  Playlist& random();

  Playlist& add(const std::string&, const bool sort=false, const bool addDir=false);
  Playlist& randomize();
  Playlist& sort();

 private:
  Playlist(const Playlist&);
  Playlist& operator=(const Playlist&);;
};

#endif
